"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Checkbox = void 0;
const react_1 = __importStar(require("react"));
const clsx_1 = __importDefault(require("clsx"));
const enums_1 = require("@procyon/types/enums");
const CheckSquare_1 = require("./Icons/CheckSquare");
const Square_1 = require("./Icons/Square");
const Checkbox = (props) => {
    const { label, description, name, status = enums_1.StatusEnum.none, disabled } = props;
    const [checked, setChecked] = (0, react_1.useState)(false);
    (0, react_1.useEffect)(() => {
        setChecked(props.checked || false);
    }, [props.checked]);
    const handleClick = (0, react_1.useCallback)((e) => {
        if (props.onChange) {
            props.onChange(!checked, e);
        }
        setChecked(!checked);
    }, [checked]);
    const handleBlur = (0, react_1.useCallback)((e) => {
        if (props.onBlur) {
            props.onBlur(checked, e);
        }
    }, [checked]);
    return (react_1.default.createElement("div", { className: (0, clsx_1.default)('field-container checkbox-container', {
            'field-container--info': status === enums_1.StatusEnum.info,
            'field-container--success': status === enums_1.StatusEnum.success,
            'field-container--warning': status === enums_1.StatusEnum.warning,
            'field-container--error': status === enums_1.StatusEnum.error,
            'field-container--nolabel': !label
        }) },
        react_1.default.createElement("input", { id: name, name: name, className: "hidden field-input", type: "checkbox", onBlur: handleBlur, disabled: disabled }),
        label && (react_1.default.createElement("label", { className: "field-label", htmlFor: name, onClick: handleClick }, label)),
        react_1.default.createElement("div", { className: "field-checkbox", onClick: handleClick },
            checked ? react_1.default.createElement(CheckSquare_1.CheckSquareIcon, { className: "mr-1 field-icon" }) : react_1.default.createElement(Square_1.SquareIcon, { className: "mr-1 field-icon" }),
            description)));
};
exports.Checkbox = Checkbox;
