"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
const clsx_1 = __importDefault(require("clsx"));
const scroll_into_view_if_needed_1 = __importDefault(require("scroll-into-view-if-needed"));
const utils_1 = require("@procyon/utils");
const TextField_1 = require("./TextField");
const List = ({ options, autoComplete, onChange, compact, name, scrollToCode, className, selectedCode, enableAutoScroll, }) => {
    const [index, setIndex] = (0, react_1.useState)(0);
    const [selectedItemCode, setSelectedItemCode] = (0, react_1.useState)(selectedCode);
    const [searchResults, setSearchResults] = (0, react_1.useState)(options);
    const scrollToItem = (index) => {
        if (enableAutoScroll) {
            const element = document.querySelector(`#list-${name}_${index}`);
            (0, scroll_into_view_if_needed_1.default)(element, {
                scrollMode: 'if-needed',
                behavior: 'smooth',
                block: 'center',
            });
        }
    };
    (0, react_1.useEffect)(() => {
        if (!(0, utils_1.isNilOrEmpty)(selectedCode) && selectedCode !== selectedItemCode) {
            setSelectedItemCode(selectedCode);
        }
    }, [selectedCode, selectedItemCode]);
    const setCurrentOption = (index) => () => {
        setIndex(index);
    };
    const setActiveOption = (option) => () => {
        setSelectedItemCode(option.code);
        onChange === null || onChange === void 0 ? void 0 : onChange(option);
    };
    const handleKeyUp = (event) => {
        let newIndex = index;
        switch (event.key) {
            case 'ArrowDown':
                newIndex += 1;
                break;
            case 'ArrowUp':
                newIndex -= 1;
                break;
            case 'Enter':
                setActiveOption(searchResults[index])();
                return;
            default:
                return;
        }
        event.preventDefault();
        if (newIndex < 0) {
            newIndex = 0;
        }
        else if (newIndex > searchResults.length - 1) {
            newIndex = searchResults.length - 1;
        }
        setIndex(newIndex);
        scrollToItem(newIndex);
    };
    (0, react_1.useEffect)(() => {
        window.addEventListener('keydown', handleKeyUp);
        return () => {
            window.removeEventListener('keydown', handleKeyUp);
        };
    }, [handleKeyUp]);
    (0, react_1.useEffect)(() => {
        if (options && selectedItemCode) {
            const optionIndex = (0, ramda_1.findIndex)((0, ramda_1.propEq)(selectedItemCode, 'code'), options);
            if (optionIndex !== -1) {
                setIndex(optionIndex);
                scrollToItem(optionIndex);
            }
        }
        if (options && scrollToCode && !selectedItemCode) {
            const optionIndex = (0, ramda_1.findIndex)((0, ramda_1.propEq)(scrollToCode, 'code'), options);
            if (optionIndex !== -1) {
                scrollToItem(optionIndex);
            }
        }
    }, [options, selectedItemCode, name]);
    const handleSearch = (value) => {
        setSearchResults((0, ramda_1.filter)((0, ramda_1.compose)((0, ramda_1.includes)((0, ramda_1.toLower)(value)), ramda_1.toLower, (0, ramda_1.prop)('name')))(options));
        setIndex(0);
    };
    const items = (0, react_1.useMemo)(() => {
        if (!(0, utils_1.isNilOrEmpty)(searchResults)) {
            return searchResults.map((option, i) => {
                return (react_1.default.createElement("div", { key: option.code, id: `list-${name}_${i}`, className: (0, clsx_1.default)('list', {
                        'list-compact': compact,
                        'list--focus': index === i,
                        'list--active': selectedItemCode === option.code,
                    }), onClick: setActiveOption({ code: option.code, name: option.name }), onMouseEnter: setCurrentOption(i) },
                    react_1.default.createElement("div", null, option.name),
                    option.description && react_1.default.createElement("div", null, option.description)));
            });
        }
        else {
            return react_1.default.createElement("div", null, "Nic k zobrazen\u00ED");
        }
    }, [searchResults, index, selectedItemCode, name]);
    return (react_1.default.createElement("div", null,
        autoComplete && (react_1.default.createElement("div", { className: "pb-4" },
            react_1.default.createElement(TextField_1.TextField, { name: "search", label: "Hledat", onChange: handleSearch, autoFocus: true }))),
        react_1.default.createElement("div", { className: (0, clsx_1.default)('list-container', className), onMouseLeave: setCurrentOption(-1) }, items)));
};
List.displayName = 'List';
exports.default = List;
