"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Message = void 0;
const react_1 = __importDefault(require("react"));
const clsx_1 = __importDefault(require("clsx"));
const enums_1 = require("@procyon/types/enums");
const CheckCircle_1 = require("./Icons/CheckCircle");
const ExclamationCircle_1 = require("./Icons/ExclamationCircle");
const ExclamationTriangle_1 = require("./Icons/ExclamationTriangle");
const InfoCircle_1 = require("./Icons/InfoCircle");
const Message = ({ status = enums_1.StatusEnum.none, title, children, className }) => (react_1.default.createElement("div", { className: (0, clsx_1.default)('message', className, {
        'message--none': status === enums_1.StatusEnum.none,
        'message--info': status === enums_1.StatusEnum.info,
        'message--success': status === enums_1.StatusEnum.success,
        'message--warning': status === enums_1.StatusEnum.warning,
        'message--error': status === enums_1.StatusEnum.error
    }) },
    react_1.default.createElement("div", null,
        status === enums_1.StatusEnum.info && react_1.default.createElement(InfoCircle_1.InfoCircleIcon, null),
        status === enums_1.StatusEnum.success && react_1.default.createElement(CheckCircle_1.CheckCircleIcon, null),
        status === enums_1.StatusEnum.warning && react_1.default.createElement(ExclamationTriangle_1.ExclamationTriangleIcon, null),
        status === enums_1.StatusEnum.error && react_1.default.createElement(ExclamationCircle_1.ErrorIcon, null),
        status === enums_1.StatusEnum.none && react_1.default.createElement(InfoCircle_1.InfoCircleIcon, null)),
    react_1.default.createElement("div", { className: "max-w-full" },
        react_1.default.createElement("div", null,
            title && react_1.default.createElement("div", { className: "text-lg mb-1" }, title),
            react_1.default.createElement("div", { className: "text-sm" }, children)))));
exports.Message = Message;
