"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Toasters = exports.ToastersPosition = void 0;
const react_1 = __importDefault(require("react"));
const clsx_1 = __importDefault(require("clsx"));
const utils_1 = require("@procyon/utils");
const Message_1 = require("../../Message");
const hooks_1 = require("../hooks");
var ToastersPosition;
(function (ToastersPosition) {
    ToastersPosition["BottomCenter"] = "bottomCenter";
    ToastersPosition["BottomLeft"] = "bottomLeft";
    ToastersPosition["BottomRight"] = "bottomRight";
    ToastersPosition["LeftCenter"] = "leftCenter";
    ToastersPosition["RightCenter"] = "rightCenter";
    ToastersPosition["TopCenter"] = "topCenter";
    ToastersPosition["TopLeft"] = "topLeft";
    ToastersPosition["TopRight"] = "topRight";
})(ToastersPosition || (exports.ToastersPosition = ToastersPosition = {}));
function Toasters({ position }) {
    const { toasters } = (0, hooks_1.useToaster)();
    if ((0, utils_1.isNilOrEmpty)(toasters)) {
        return null;
    }
    return (react_1.default.createElement("div", { className: (0, clsx_1.default)('toasters', {
            'toasters--topLeft': ToastersPosition.TopLeft === position,
            'toasters--topCenter': ToastersPosition.TopCenter === position,
            'toasters--topRight': ToastersPosition.TopRight === position,
            'toasters--rightCenter': ToastersPosition.RightCenter === position,
            'toasters--bottomRight': ToastersPosition.BottomRight === position,
            'toasters--bottomCenter': ToastersPosition.BottomCenter === position,
            'toasters--bottomLeft': ToastersPosition.BottomLeft === position,
            'toasters--leftCenter': ToastersPosition.LeftCenter === position,
        }) }, Object.keys(toasters).map((toasterId) => {
        const toaster = toasters[toasterId];
        return (react_1.default.createElement(Message_1.Message, { key: toasterId, status: toaster.status, title: toaster.title }, toaster.message));
    })));
}
exports.Toasters = Toasters;
